import math
import pygame
import numpy as np
pygame.font.init()

screen = pygame.display.set_mode((0, 0), pygame.FULLSCREEN )
width, height = w, h = pygame.display.get_surface().get_size()
white_width = 3/4*width

# Farben
white = (255, 255, 255)
black = (0 , 0, 0)
red = (255, 0, 0)
grey = (200, 200, 200)
darkgrey = (100, 100, 100)
green = (0, 255, 0)
yellow = (255, 255, 0)
darkred = (94, 32, 40)
blue = (0,0,255)

# Schriftarten
comicsans = pygame.font.SysFont('comicsans', round(2*width/100))
comicsans_g = pygame.font.SysFont('comicsans', round(3*width/100))
comicsans_kl = pygame.font.SysFont('comicsans', round(1*width/100))
comicsans_20 = pygame.font.SysFont('comicsans', round(1.5*width/100))

# Buttons
horizontal = 0
vertikal = 0
diagonal = 0

# Anfangszähler
anfang = 0

# Knotenpunkte (Nummer : Koordinatentupel)
knotenpunkte = []

# Reset-Optionen
breite = 3/4*(1/2*(1/4*width))
hoehe = 3/4*(1/3*(1/3*height))
undo = pygame.Rect(20+breite, 10, breite, hoehe)
reset = False

#Quit-Button
breite =  3/4*(3/4*(1/2*(1/4*width)))
hoehe = 3/4*(3/4*(1/3*(1/3*height)))
quit = pygame.Rect(width-(10+breite), 10, breite, hoehe)


# Fertig-Button
f_laenge = breite
f_hoehe = breite
fertig = pygame.Rect((3/4*width-10)-f_laenge, 10, f_laenge, f_hoehe)
fertig_zustand = False

# Eingabefeld für die Kraft
kf_laenge = 3/5*(1/2*width)
kf_hoehe = (3/4*(1/3*height)) * 1/2
kf_x = (3/4*width-10)-kf_laenge
kf_y = 10
kf = pygame.Rect(kf_x, kf_y, kf_laenge, kf_hoehe)
kf_halbe = pygame.Rect((3/4*width-10)-kf_laenge + kf_laenge*1/2, 10, kf_laenge*1/2, kf_hoehe )
kraft_string = ""
kraft_betrag = 0
kraft_liste = []
kraft_punkt_liste = []
kraft_dir_liste = []

kraft_punkt_benoetigt = False
kraft_vorhanden = False
kraft_richtung_benoetigt = False

senkrecht_aktiviert = False
waagerecht_aktiviert = False

kf_richtung = pygame.Rect((3/4*width-10)-kf_laenge, 10, kf_laenge, kf_hoehe)
kleine_optionen1 = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) , 10+kf_hoehe/2 , 1/2*(1/2*(1/4*width)),1/2*(1/3*(1/3*height)))
kleine_optionen2 = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width))) , 10+kf_hoehe/2 , 1/2*(1/2*(1/4*width)),1/2*(1/3*(1/3*height)))
kleine_optionen3 = pygame.Rect((3/4*width-10)-kf_laenge+3*((kf_laenge-3*1/2*(1/2*(1/4*width)))/4)+2*1/2*(1/2*(1/4*width)) , 10+kf_hoehe/2 , 1/2*(1/2*(1/4*width)),1/2*(1/3*(1/3*height)))

von_oben = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),(1/2*(1/3*(1/3*height))))
von_unten = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) + 1/2*(1/2*(1/2*(1/4*width))), 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))), 1/2*(1/3*(1/3*height)))

von_links = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width))) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),1/2*(1/3*(1/3*height)))
von_rechts = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width))) + 1/2*(1/2*(1/2*(1/4*width))) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),1/2*(1/3*(1/3*height)))

# Festlager
seitenlaenge = 40
x_linksunten = 1/5*(3/4*width) - seitenlaenge
y_linksunten = 4/5*height
spitze = (x_linksunten + seitenlaenge/2, y_linksunten - math.sqrt(seitenlaenge**2 - (seitenlaenge/2)**2) )

# Loslager
#x_linksunten2 = x_linksunten + 4*x_linksunten
spitze2 = (x_linksunten + seitenlaenge/2 +4*x_linksunten , y_linksunten - math.sqrt(seitenlaenge**2 - (seitenlaenge/2)**2) )

# Eingabefeld für den Abstand
abst_breite = 1/2*(1/4*width)
abst_hoehe = 1/3*(1/3*height)
abst_x = white_width/2 - abst_breite/2
abst_y = height/2 - abst_hoehe/2
abstand_feld = pygame.Rect(abst_x, abst_y, abst_breite, abst_hoehe)
dunkel_abs = True
hell_abs = False

# Berechnungs und Wietere Kraft-Feld
fb_laenge = 0.8*(1/2*kf_laenge)
fb_hoehe = 0.8*kf_hoehe
fb_x = kf_x + 0.1*(1/2*kf_laenge)
fb_y = kf_y + 0.1*kf_hoehe

fwk_laenge = fb_laenge
fwk_hoehe = fb_hoehe
fwk_x = fb_x + 1/2*kf_laenge
fwk_y = fb_y

feld_berechnen = pygame.Rect(fb_x, fb_y, fb_laenge, fb_hoehe)
feld_weitere_kraft = pygame.Rect(fwk_x, fwk_y, fwk_laenge, fwk_hoehe)

berechnen_moeglich = False

# maximale Kräfte
max_options1 = False
max_options2 = False

lagerkraft_string = ""
stabkraft_string = ""

lagerkraft_betrag = 0
stabkraft_betrag = 0

# Zahlendictionary
zahlen = {pygame.K_0 : "0", pygame.K_1 : "1", pygame.K_2 : "2", pygame.K_3 : "3", pygame.K_4 : "4", pygame.K_5 : "5", pygame.K_6 : "6", pygame.K_7 : "7", pygame.K_8 : "8", pygame.K_9 : "9", pygame.K_COMMA : ".", pygame.K_PERIOD : ".", }

# Abstand
abstand_benoetigt = True
abstand_string = ""
abstand = 0

# Anfangsposition der Knotenpunkte
start_pos = spitze


kraft_dir = []


screen.fill(white)
pygame.display.update()

# Funktion überprüft, ob System statisch bestimmt ist
def statisch_bestimmt():
    points = []
    print(knotenpunkte)
    points.append(knotenpunkte[0])
    for i in knotenpunkte[2:]:
        points.append(tuple(i))
    print(points)
    # Anzahl einzigartiger Knotenpunkte, Liste einzigartiger Knotenpunkte
    amount_knoten = len(set(points))
    knoten = list(set(points))
    # Alle Verbindungen zwischen 2 Punkten
    connections = []
    for i in range(len(points) - 1):
        if [points[i], points[i+1]] and [points[i+1], points[i]] not in connections:
            connections.append([points[i], points[i+1]])

    # Alle Verbindungen werden geordnet
    for i in connections:
        if i[0][0] > i[1][0]:
            i[0], i[1] = i[1], i[0]
    #print(connections)
    # Parameter, ob das System statisch bestimmt ist
    statisch = True
    # Es werden alle Verbindungen von jeweils 2 Verbindungspunkten in Listen gespeichert und die Schnittmenge wird zusammengeführt
    if 2 * amount_knoten != len(connections) + 3:
        return False
    for i in connections:
        connected = []
        connected1 = []
        connected2 = []
        for k in connections:
            if i != k:
                if i[0] == k[0]:
                    connected1.append(k[1])
                if i[0] == k[1]:
                    connected1.append(k[0])
                if i[1] == k[0]:
                    connected2.append(k[1])
                if i[1] == k[1]:
                    connected2.append(k[0])
        connected1 = set(connected1)
        connected2 = set(connected2)
        #print(connected2)
        connected = connected1 & connected2
        connected = list(connected)
        #print(connected)
        #print(len(connected))

    # Es wird überprüft, ob die Konstruktion statisch bestimmt ist
        if len(connected) > 2 or len(connected) == 0:
            return False
            break
        if len(connected) == 2 and i[0][0] != i[1][0]:
            m = ((i[1][1] - i[0][1])/(i[1][0] - i[0][0]))
            if connected[0][1] > m * connected[0][0] + i[0][1] - m * i[0][0] and connected[1][1] > m * connected[1][0] + i[0][1] - m * i[0][0]:
                return False
                break
            if  connected[0][1] < m * connected[0][0] + i[0][1] - m * i[0][0] and connected[1][1] < m * connected[1][0] + i[0][1] - m * i[0][0]:
                return False
                break
        if len(connected) == 2 and i[0][0] == i[1][0]:
            if (connected[0][0] > i[0][0] and connected[1][0] > i[0][0]) or (connected[0][0] < i[0][0] and connected[1][0] < i[0][0]):
                return False
                break

        if statisch:
            return True



def main():
    run = True

    global anfang
    global abstand
    global undo
    global quit
    global x
    global abstand_string
    global abstand_benoetigt
    global spitze
    global spitze2
    global kf_halbe
    global kraft_betrag
    global kraft_string
    global kraft_liste
    global fertig_zustand
    global kraft_punkt_benoetigt
    global kraft_vorhanden
    global kraft_richtung_benoetigt
    global senkrecht_aktiviert
    global waagerecht_aktiviert
    global von_oben
    global von_unten
    global von_links
    global von_rechts
    global berechnen_moeglich
    global max_options1
    global max_options2
    global lagerkraft_string
    global stabkraft_string
    global stabkraft_betrag
    global lagerkraft_betrag



    draw_menu()
    draw_resetoptions()
    draw_fertig()
    draw_eingabefeld_abstand()
    draw_quit()



    while run:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                run = False
                pygame.quit()

            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_p:
                    print(knotenpunkte)

                if event.type == pygame.KEYDOWN:
                    if event.key in zahlen:

                        if abstand_benoetigt == True: # Eingabe des Abstands (nur falls dieser noch nicht angegeben ist)
                            abstand_string += zahlen[event.key]
                            abstand_anzeige = comicsans.render(abstand_string, 1, black)
                            pygame.draw.rect(screen, grey, abstand_feld)
                            screen.blit(abstand_anzeige, (white_width/2 - abstand_anzeige.get_width()/2, abst_y + abst_hoehe/2 - abstand_anzeige.get_height()/2 ))

                        if fertig_zustand == True and max_options2 == True: # Prüft, ob das Zeichnen der Stäbe beendet wurde
                            kraft_string += zahlen[event.key]
                            kraft_anzeige = comicsans_g.render(kraft_string, 1, black)
                            pygame.draw.rect(screen, grey, kf_halbe)
                            screen.blit(kraft_anzeige, (((3/4*width-10)-kf_laenge/2 + kf_laenge/4)-kraft_anzeige.get_width()/2, (10+kf_hoehe/2)-kraft_anzeige.get_height()/2))

                        if fertig_zustand == False and max_options1 == True:
                            lagerkraft_string += zahlen[event.key]
                            lagerkraft_anzeige = comicsans_g.render(lagerkraft_string, 1, black)
                            pygame.draw.rect(screen, grey, kf_halbe)
                            screen.blit(lagerkraft_anzeige, (((3/4*width-10)-kf_laenge/2 + kf_laenge/4)-lagerkraft_anzeige.get_width()/2, (10+kf_hoehe/2)-lagerkraft_anzeige.get_height()/2))

                        if fertig_zustand == False and max_options2 == True:
                            stabkraft_string += zahlen[event.key]
                            stabkraft_anzeige = comicsans_g.render(stabkraft_string, 1, black)
                            pygame.draw.rect(screen, grey, kf_halbe)
                            screen.blit(stabkraft_anzeige, (((3/4*width-10)-kf_laenge/2 + kf_laenge/4)-stabkraft_anzeige.get_width()/2, (10+kf_hoehe/2)-stabkraft_anzeige.get_height()/2))


                    if event.key == pygame.K_RETURN:
                        if abstand_benoetigt == True: # Beenden der Eingabe des Abstandes, Eingabe-string wird in float umgewandelt
                            abstand = float(abstand_string)
                            if abstand+spitze[0]+seitenlaenge/2 < white_width: # Überprüfung, ob Abstand klein genug ist
                                print(abstand)
                                abstand_benoetigt = False
                                normales_layout()
                                draw_festlager()
                                draw_loslager()
                                knotenpunkte.append(spitze)
                                knotenpunkte.append(spitze2)
                            else:
                                pygame.draw.rect(screen, darkgrey, abstand_feld)
                                fehlermeldung_1 = comicsans_20.render("Wähle bitte ", 1, black)
                                screen.blit(fehlermeldung_1, (white_width/2 - fehlermeldung_1.get_width()/2, abst_y + abst_hoehe/2 - fehlermeldung_1.get_height()/2 - (fehlermeldung_1.get_height()+1)))
                                fehlermeldung_2 = comicsans_20.render("einen kleineren Abstand!", 1, black)
                                screen.blit(fehlermeldung_2, (white_width/2 - fehlermeldung_2.get_width()/2, abst_y + abst_hoehe/2 - fehlermeldung_2.get_height()/2 + 1))
                                abstand_string = ""

                        if fertig_zustand == True and max_options2 == True: # nach Krafteingabe, Kraft wird in Liste gespeichert
                            kraft_betrag = float(kraft_string)
                            #print(kraft_betrag) # überprüfung
                            kraft_liste.append(kraft_betrag)
                            kraft_string = ""
                            #print(kraft_liste)
                            # nächster Schritt: user soll knotenpunkt anklicken, user muss richtung auswählen, dann entweder noch eine Kraft eingeben oder auf "Berechnung" klicken
                            draw_kraftpunktfeld()



                        if fertig_zustand == False and max_options1 == True:
                            lagerkraft_betrag = float(lagerkraft_string)
                            max_options1 = False
                            max_options2 = True
                            print("Lagerkraft:",lagerkraft_betrag)
                            draw_maxstabfeld()
                            continue

                        if fertig_zustand == False and max_options2 == True:
                            stabkraft_betrag = float(stabkraft_string)
                            #max_options2 = False ###############################################################
                            click_fertig()
                            continue


                pygame.display.update()

            if event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                pos = pygame.mouse.get_pos()
                x,y = pos
                #if abstand_feld.collidepoint(x,y):
                    #click_and_write_abstand()

                    #continue
                if von_oben.collidepoint(x,y) and senkrecht_aktiviert == True:  # Pfeiloptionen SENKrecht und von_OBEN sind ausgewählt
                    force_dir = np.array([0, 1])
                    kraft_dir.append((0,1))
                    kraft_dir_liste.append(force_dir)
                    draw_arrow_senkrecht(ende, laenge, force_dir)
                    senkrecht_aktiviert = False
                    berechnen_moeglich = True
                    draw_berechnen_oder_kraft()
                    continue

                if von_unten.collidepoint(x,y) and senkrecht_aktiviert == True: # Pfeiloptionen SENKrecht und von_UNTEN sind ausgewählt
                    force_dir = np.array([0, -1])
                    kraft_dir.append((0,-1))
                    #neues_ende = [ende[0], ende[1]-laenge]
                    kraft_dir_liste.append(force_dir)
                    draw_arrow_senkrecht(ende, laenge, force_dir, n=-1)
                    senkrecht_aktiviert = False
                    berechnen_moeglich = True
                    draw_berechnen_oder_kraft()
                    continue

                if von_links.collidepoint(x,y) and waagerecht_aktiviert == True: # Pfeiloptionen WAAGErecht und von_LINKS sind ausgewählt
                    force_dir = np.array([1, 0])
                    kraft_dir.append((1,0))
                    kraft_dir_liste.append(force_dir)
                    draw_arrow_waagerecht(ende, laenge, force_dir)
                    Waagerecht_aktiviert = False
                    berechnen_moeglich = True
                    draw_berechnen_oder_kraft()
                    continue

                if von_rechts.collidepoint(x,y) and waagerecht_aktiviert == True: # Pfeiloptionen WAAGErecht und von_RECHTS sind ausgewählt
                    force_dir = np.array([-1, 0])
                    kraft_dir.append((-1,0))
                    #neues_ende = [ende[0], ende[1]-laenge]
                    kraft_dir_liste.append(force_dir)
                    draw_arrow_waagerecht(ende, laenge, force_dir, n=-1)
                    waagerecht_aktiviert = False
                    berechnen_moeglich = True
                    draw_berechnen_oder_kraft()
                    continue

                if feld_berechnen.collidepoint(x,y) and berechnen_moeglich == True:
                    click_berechnen()

                if feld_weitere_kraft.collidepoint(x,y) and berechnen_moeglich == True:
                    berechnen_moeglich = False
                    click_fertig()

                if kraft_punkt_benoetigt == True:
                    for punkt in knotenpunkte:
                        for x_k,y_k in knotenpunkte:
                            if x-10 < x_k < x+10 and y-10 < y_k < y+10:
                                pygame.draw.circle(screen, green, (x_k, y_k), 10)
                                punkt_gruen = [x_k, y_k]
                                draw_kraftrichtungfeld()
                                kraft_punkt_benoetigt = False
                                kraft_richtung_benoetigt = True
                    kraft_vorhanden = True
                    kraft_punkt_liste.append(punkt_gruen)
                    continue

                # Alle Sachen, die im weißen Fenster angeklickt werden:
                if pos[0] <= 3/4*width:
                    if undo.collidepoint(x,y) and fertig_zustand == False: # 2 mal gleiche if Bedinung --> Verbessern?
                        click_undo()
                        if reset:
                            start_pos = spitze #knotenpunkte[-1]
                        continue
                    if fertig.collidepoint(x,y) and abstand_benoetigt == False and fertig_zustand == False: # auch hier wie bei click_undo
                    # --- Überprüfung der statischen Bestimmtheit -----
                        static = statisch_bestimmt()
                        print(static)
                        if static == True:
                            max_options1 = True
                            max_options2 = False
                            #click_fertig()
                            draw_maxlagerfeld()
                            continue
                        if static == False:
                            fehlermeldung_statisch()
                            pygame.display.update()
                            pygame.time.delay(3000)
                            pygame.quit()
                            #" RESET "

                            #normales_layout()
                        print("test")
                        max_options1 = True
                        max_options2 = False
                        draw_maxlagerfeld()
                        #click_fertig()
                        continue

                    if quit.collidepoint(x,y):
                        click_quit()
                    if kraft_richtung_benoetigt == True: #  kraft_vorhanden == True and
                        ende = np.array(punkt_gruen)
                        laenge = kraft_betrag

                        # Länge des Pfeils = Betrag, Ende(Spitze des Pfeils) = Mittelpunkt grüner Knoten, Start --> Berechnen

                        if kleine_optionen1.collidepoint(x,y): # senkrecht

                            draw_optionen_senkrecht()
                            #for happening in pygame.event.get():
                                #if event.type == pygame.QUIT:
                                #    run = False
                                #    pygame.quit()
                                #if happening.type == pygame.MOUSEBUTTONDOWN and happening.button == 1:
                                #    x,y = pygame.mouse.get_pos()
                                #    if von_oben.collidepoint(x,y):
                                #        force_dir = np.array([0, 1])
                                #        draw_arrow_senkrecht(ende, laenge, force_dir)
                                #    if von_unten.collidepoint(x,y):
                                #        force_dir = np.array([0, -1])
                                #        #neues_ende = [ende[0], ende[1]-laenge]
                                #        draw_arrow_senkrecht(ende, laenge, force_dir, n=-1)


                            # senkrechten Pfeil malen
                            senkrecht_aktiviert = True
                            kraft_richtung_benoetigt = False

                        if kleine_optionen2.collidepoint(x,y):

                            force_dir = np.array([1, 0])
                            draw_optionen_waagerecht()
                            #draw_arrow_waagerecht(ende, laenge, force_dir)

                            # waagerechten Pfeil malen
                            waagerecht_aktiviert = True
                            kraft_richtung_benoetigt = False

                        #if kleine_optionen3.collidepoint(x,y):

                            # Malen eines Pfeils
                            # hin- und herzubewegender Pfeil in Kreis mit Mittelpunkt = Mittelpunkt von grünem Knoten und Radius = Betrag der Kraft
                            #kraft_richtung_benoetigt = False



                    if pos[0] <=  3/4*width-10 and abstand_benoetigt == False and kraft_vorhanden == False:
                        if anfang == 0:
                            # nur ein einzelner Knotenpunkt (ohne Stab) wird am Anfang gezeichnet
                            pygame.draw.circle(screen, red, spitze, 10)
                            start_pos = spitze #pos
                            anfang += 1
                            #knotenpunkte.append(pos)
                        elif anfang == 1:
                            x,y = pygame.mouse.get_pos()
                            for x_k,y_k in knotenpunkte:   # wird auf einen Schon vorhandenen Punkt geklickt, wird der stab auch da angesetzt
                                if x-10 < x_k < x+10:  # ist  nur der x-Wert in dem Bereich, verläuft der neue stab parallel zu einem schon vorhandenen horizontalen stab
                                    x = x_k
                                if y-10 < y_k < y+10: # ist nur der y-Wert in dem Bereich, verläuft der neue Stab parallel zu einem schon vorhandenen vertikalen Stab
                                    y = y_k


                            if horizontal == 1:
                                if len(knotenpunkte) > 2:
                                    start_pos = knotenpunkte[-1]
                                else:
                                    start_pos = knotenpunkte[0]
                                stab_mit_punkt(start_pos, (x, start_pos[1]))
                                start_pos = [x, start_pos[1]]
                                knotenpunkte.append(start_pos)

                            elif vertikal == 1:
                                if len(knotenpunkte) > 2:
                                    start_pos = knotenpunkte[-1]
                                else:
                                    start_pos = knotenpunkte[0]
                                stab_mit_punkt(start_pos, (start_pos[0], y))
                                start_pos = [start_pos[0], y]
                                knotenpunkte.append(start_pos)

                            elif diagonal == 1:
                                if len(knotenpunkte) > 2:
                                    start_pos = knotenpunkte[-1]
                                else:
                                    start_pos = knotenpunkte[0]
                                stab_mit_punkt(start_pos, (x,y))
                                start_pos = [x,y]
                                knotenpunkte.append(start_pos)

                        click_reset()




                # Alle Sachen, die im Menü angeklickt werden
                elif pos[0] >= 3/4*width:
                    auswahl()
                    click_quit()



            pygame.display.update()


# Menü mit Optionen
def draw_menu():
    # Kasten insgesamt
    kasten = pygame.Rect(3/4*width, 0, 1/4*width, height)
    pygame.draw.rect(screen, black, kasten)

    # Kästchen für horizontale Stäbe
    x1_links = 3/4*width + 1/4*(1/4*width)
    y1_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2
    w1 = 1/2*(1/4*width)
    l1 = 1/3*(1/3*height)

    option1 = pygame.Rect(x1_links, y1_oben, w1, l1)
    option1_text = comicsans.render("horizontal", 1, black)
    pygame.draw.rect(screen, white, option1)
    screen.blit(option1_text, ((x1_links+w1/2)-(option1_text.get_width()/2), (y1_oben+l1/2)-(option1_text.get_height()/2)) )

    # Kästchen für vertikale Stäbe
    x2_links = x1_links
    y2_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2 + 1/3*height
    w2 = w1
    l2 = l1

    option2 = pygame.Rect(x2_links, y2_oben, w2, l2)
    option2_text = comicsans.render("vertikal", 1, black)
    pygame.draw.rect(screen, white, option2)
    screen.blit(option2_text, ((x2_links+w2/2)-(option2_text.get_width()/2), (y2_oben+l2/2)-(option2_text.get_height()/2)) )

    # Kästchen für diagonale Stäbe
    x3_links = x1_links
    y3_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2 + 2/3*height
    w3 = w1
    l3 = l1

    option3 = pygame.Rect(x3_links, y3_oben, w3, l3)
    option3_text = comicsans.render("diagonal", 1, black)
    pygame.draw.rect(screen, white, option3)
    screen.blit(option3_text, ((x3_links+w3/2)-(option3_text.get_width()/2), (y3_oben+l3/2)-(option3_text.get_height()/2)) )

# Zeichnen der Stäbe
def stab_mit_punkt(start, end):
    pygame.draw.line(screen, black, start, end, 5)
    pygame.draw.circle(screen, black, start, 10)
    pygame.draw.circle(screen, red, end, 10)

# Anklicken der zur Auswahl stehenden Optionen
def auswahl():
    x,y = pygame.mouse.get_pos()

    x1_links = 3/4*width + 1/4*(1/4*width)
    y1_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2
    w1 = 1/2*(1/4*width)
    l1 = 1/3*(1/3*height)
    x2_links = x1_links
    y2_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2 + 1/3*height
    w2 = w1
    l2 = l1
    x3_links = x1_links
    y3_oben = 1/2*(1/3*height)-(1/3*(1/3*height))/2 + 2/3*height
    w3 = w1
    l3 = l1


    option1 = pygame.Rect(x1_links, y1_oben, w1, l1)
    option2 = pygame.Rect(x2_links, y2_oben, w2, l2)
    option3 = pygame.Rect(x3_links, y3_oben, w3, l3)

    global horizontal
    global vertikal
    global diagonal


    if option1.collidepoint(x, y) and anfang == 1:
        horizontal = 1
        vertikal = 0
        diagonal = 0


        option1_text = comicsans.render("horizontal", 1, black) # Farbänderung hier
        pygame.draw.rect(screen, grey, option1)
        screen.blit(option1_text, ((x1_links+w1/2)-(option1_text.get_width()/2), (y1_oben+l1/2)-(option1_text.get_height()/2)) )

        option2_text = comicsans.render("vertikal", 1, black)
        pygame.draw.rect(screen, white, option2)
        screen.blit(option2_text, ((x2_links+w2/2)-(option2_text.get_width()/2), (y2_oben+l2/2)-(option2_text.get_height()/2)) )

        option3_text = comicsans.render("diagonal", 1, black)
        pygame.draw.rect(screen, white, option3)
        screen.blit(option3_text, ((x3_links+w3/2)-(option3_text.get_width()/2), (y3_oben+l3/2)-(option3_text.get_height()/2)) )

    elif option2.collidepoint(x, y) and anfang == 1:
        horizontal = 0
        vertikal = 1
        diagonal = 0

        option1_text = comicsans.render("horizontal", 1, black)
        pygame.draw.rect(screen, white, option1)
        screen.blit(option1_text, ((x1_links+w1/2)-(option1_text.get_width()/2), (y1_oben+l1/2)-(option1_text.get_height()/2)) )

        option2_text = comicsans.render("vertikal", 1, black) # Farbänderung hier
        pygame.draw.rect(screen, grey, option2)
        screen.blit(option2_text, ((x2_links+w2/2)-(option2_text.get_width()/2), (y2_oben+l2/2)-(option2_text.get_height()/2)) )

        option3_text = comicsans.render("diagonal", 1, black)
        pygame.draw.rect(screen, white, option3)
        screen.blit(option3_text, ((x3_links+w3/2)-(option3_text.get_width()/2), (y3_oben+l3/2)-(option3_text.get_height()/2)) )
    elif option3.collidepoint(x, y) and anfang == 1:
        horizontal = 0
        vertikal = 0
        diagonal = 1

        option1_text = comicsans.render("horizontal", 1, black)
        pygame.draw.rect(screen, white, option1)
        screen.blit(option1_text, ((x1_links+w1/2)-(option1_text.get_width()/2), (y1_oben+l1/2)-(option1_text.get_height()/2)) )

        option2_text = comicsans.render("vertikal", 1, black)
        pygame.draw.rect(screen, white, option2)
        screen.blit(option2_text, ((x2_links+w2/2)-(option2_text.get_width()/2), (y2_oben+l2/2)-(option2_text.get_height()/2)) )

        option3_text = comicsans.render("diagonal", 1, black) # Farbänderung hier
        pygame.draw.rect(screen, grey, option3)
        screen.blit(option3_text, ((x3_links+w3/2)-(option3_text.get_width()/2), (y3_oben+l3/2)-(option3_text.get_height()/2)) )

# Zeichnen der Kästchen für einen Reset und einen Schritt zurück
def draw_resetoptions():
    # Reset-Button
    breite = 3/4*(1/2*(1/4*width))
    hoehe = 3/4*(1/3*(1/3*height))

    reset = pygame.Rect(10, 10, breite, hoehe)
    reset_text = comicsans_g.render("Reset", 1, white)

    text_x = (10+breite/2)-reset_text.get_width()/2
    text_y = (10+hoehe/2)-reset_text.get_height()/2

    pygame.draw.rect(screen, darkgrey, reset)
    screen.blit(reset_text, (text_x, text_y))

    # Ein-Schritt-zurück-Button
    breite = 3/4*(1/2*(1/4*width))
    hoehe = 3/4*(1/3*(1/3*height))

    undo = pygame.Rect(20+breite, 10, breite, hoehe)
    undo_text = comicsans_g.render("Undo", 1, white)

    text_x2 = (10+breite/2)-undo_text.get_width()/2 + 10 + breite
    text_y = (10+hoehe/2)-undo_text.get_height()/2

    pygame.draw.rect(screen, darkgrey, undo)
    screen.blit(undo_text, (text_x2, text_y))



# Klicken auf "Reset"
def click_reset():
    x,y = pygame.mouse.get_pos()

    breite = 3/4*(1/2*(1/4*width))
    hoehe = 3/4*(1/3*(1/3*height))
    reset = pygame.Rect(10, 10, breite, hoehe)

    global abstand_string
    global abstand_benoetigt

    if reset.collidepoint(x, y):
        screen.fill(white)
        draw_menu()
        draw_resetoptions()
        draw_fertig()
        draw_eingabefeld_abstand()
        draw_quit()
        abstand_string = ""
        abstand_benoetigt = True
        knotenpunkte.clear() # Entleeren der Knotenpunktliste
        global anfang
        anfang = 0  # Anfangscounter wird wieder auf 0 gesetzt
        global horizontal # Optionen auf ausgangszustand zurückgesetzt
        global vertikal
        global diagonal
        horizontal = 0
        vertikal = 0
        diagonal = 0

# Klicken auf "Undo"
def click_undo():

    x,y = pygame.mouse.get_pos()

    breite = 3/4*(1/2*(1/4*width))
    hoehe = 3/4*(1/3*(1/3*height))
    undo = pygame.Rect(20+breite, 10, breite, hoehe)

    if undo.collidepoint(x, y) and len(knotenpunkte) > 1:
        pygame.draw.circle(screen, white, knotenpunkte[-1], 10)
        pygame.draw.line(screen, white, knotenpunkte[-1], knotenpunkte[-2], 5)
        #knotenpunkte = knotenpunkte[:-1]
        #print(knotenpunkte)
        knotenpunkte.remove(knotenpunkte[-1]) # Entfernene des letzten Knotenpunktes
        #print(knotenpunkte)
        #print(start_pos)
        pygame.draw.circle(screen, red, knotenpunkte[-1], 10)
        #print(start_pos)
        #start_pos = knotenpunkte[-1]
        for punkt in knotenpunkte:
            if punkt != knotenpunkte[-1]:
                pygame.draw.circle(screen, black, punkt, 10)

        draw_festlager()
        draw_loslager()
        reset = False

    if undo.collidepoint(x, y) and len(knotenpunkte) == 1:
        #normales_layout()
        pygame.draw.circle(screen, white, knotenpunkte[0], 10)
        global anfang
        anfang = 0
        knotenpunkte.clear()
        reset = True


    # die Punkte springen manchmal komisch rum
    # manchmal bleibt ein Stab stehen
    # jetzt nicht mehr


# Quit-Feld zeichnen
def draw_quit():
    global breite
    global hoehe

    quit_text = comicsans_g.render("Quit", 1, white)

    text_x3 = (width-(10+breite)+breite/2)-quit_text.get_width()/2
    text_y = (10+hoehe/2)-quit_text.get_height()/2

    pygame.draw.rect(screen, darkred, quit)
    screen.blit(quit_text, (text_x3, text_y))

# Klicken auf "Quit"
def click_quit():
    global breite
    global hoehe

    x,y = pygame.mouse.get_pos()


    #quit = pygame.Rect(width-(10+breite), 10, breite, hoehe)

    if quit.collidepoint(x, y):
        run = False
        pygame.quit()


# Zeichnen eines Buttons, den man drücken soll, wenn nichts mehr zu den Stäben und Knotenpunkten an sich hinzugefügt werden soll
def draw_fertig(): # vielleicht doch englischen Namen
    global fertig
    global f_laenge
    global f_hoehe

    fertig_text = comicsans_g.render("Fertig", 1, black)

    text_x = ((3/4*width-10)-f_laenge+breite/2)-fertig_text.get_width()/2
    text_y = (10+f_laenge/2)-fertig_text.get_height()/2

    pygame.draw.rect(screen, yellow, fertig)
    screen.blit(fertig_text, (text_x, text_y))

def fehlermeldung_statisch():

    global height
    global white_width

    kasten_rot_text1 = comicsans.render("ACHTUNG:", 1, black)
    kasten_rot_text2 = comicsans.render("Die Konstruktion ist nicht statisch bestimmt!", 1, black)

    k_rot_hoehe = 2*(kasten_rot_text1.get_height()+kasten_rot_text2.get_height())
    k_rot_breite = kasten_rot_text2.get_width() + 1/3*kasten_rot_text2.get_width()

    k_rot_x = white_width/2 - k_rot_breite/2
    k_rot_y = height/2 - k_rot_hoehe/2

    kasten_rot = pygame.Rect(k_rot_x, k_rot_y, k_rot_breite, k_rot_hoehe)
    pygame.draw.rect(screen, red, kasten_rot)

    screen.blit(kasten_rot_text1, (white_width/2 - kasten_rot_text1.get_width()/2, height/2-k_rot_hoehe/4 - kasten_rot_text1.get_height()/2)  )
    screen.blit(kasten_rot_text2, (white_width/2 - kasten_rot_text2.get_width()/2, height/2+k_rot_hoehe/4 - kasten_rot_text2.get_height()/2)  )

# Abfrage maximale lager- und Stabkräfte angegeben
def draw_maxlagerfeld():

    text = comicsans_20.render("Maximale Lagerkräfte [N]: ", 1, white)
    pygame.draw.rect(screen, grey, kf)
    pygame.draw.rect(screen, darkgrey, kf_halbe)


    text_x = ((3/4*width-10)-kf_laenge + kf_laenge/4)-text.get_width()/2
    text_y = (10+kf_hoehe/2)-text.get_height()/2

    screen.blit(text, (text_x, text_y))


def draw_maxstabfeld():

    text = comicsans_20.render("Maximale Stabkräfte [N]: ", 1, white)
    pygame.draw.rect(screen, grey, kf)
    pygame.draw.rect(screen, darkgrey, kf_halbe)


    text_x = ((3/4*width-10)-kf_laenge + kf_laenge/4)-text.get_width()/2
    text_y = (10+kf_hoehe/2)-text.get_height()/2

    screen.blit(text, (text_x, text_y))

def click_fertig():
    print("Test")
    x,y = pygame.mouse.get_pos()

    global fertig
    global f_laenge
    global f_hoehe
    global kf
    global kf_halbe
    global kf_laenge
    global fertig
    global fertig_zustand


    pygame.draw.rect(screen, white, fertig)
    for position in knotenpunkte:
        pygame.draw.circle(screen, black, position, 10)
         # Feld malen mit:
         # * "Betrag der angreifenden Kraft: "
         # * "Richtung: " --> vielleicht auf schwarzer Seite auswählen ? (bei diagonal: Vektor eingeben?)
         # * "Hinzufügen" --> zuvor Knotenpunkt auswählen (anders gefärbt)
        pygame.draw.rect(screen, black, kf )
        pygame.draw.rect(screen, darkgrey, kf_halbe)

        betrag_text = comicsans_20.render("Betrag der Kraft [N]:", 1, white)

        text_x = ((3/4*width-10)-kf_laenge + kf_laenge/4)-betrag_text.get_width()/2
        text_y = (10+kf_hoehe/2)-betrag_text.get_height()/2

        screen.blit(betrag_text, (text_x, text_y))

        fertig_zustand = True

# Zeichnen eines Festlagers
def draw_festlager():
    pygame.draw.polygon(screen, black, [[x_linksunten, y_linksunten],[x_linksunten + seitenlaenge, y_linksunten],spitze], 2)
    pygame.draw.circle(screen, black, spitze, 10)
    pygame.draw.line(screen, black, [x_linksunten + seitenlaenge*1/4, y_linksunten] , [x_linksunten, y_linksunten + 5] , 2)
    pygame.draw.line(screen, black, [x_linksunten + seitenlaenge*2/4, y_linksunten] , [x_linksunten  + seitenlaenge*1/4, y_linksunten + 5] , 2)
    pygame.draw.line(screen, black, [x_linksunten + seitenlaenge*3/4, y_linksunten] , [x_linksunten  + seitenlaenge*2/4, y_linksunten + 5] , 2)
    pygame.draw.line(screen, black, [x_linksunten + seitenlaenge, y_linksunten] , [x_linksunten  + seitenlaenge*3/4, y_linksunten + 5] , 2)
    pygame.display.update()

# Zeichnen eines Loslagers
def draw_loslager():
    global abstand
    global spitze2

    pygame.draw.polygon(screen, black, [[x_linksunten + abstand, y_linksunten],[x_linksunten + seitenlaenge + abstand, y_linksunten],[x_linksunten + seitenlaenge/2 + abstand , y_linksunten - math.sqrt(seitenlaenge**2 - (seitenlaenge/2)**2) ]], 2)
    pygame.draw.circle(screen, black, [x_linksunten + seitenlaenge/2 + abstand , y_linksunten - math.sqrt(seitenlaenge**2 - (seitenlaenge/2)**2) ], 10)
    pygame.draw.line(screen, black, [x_linksunten + abstand, y_linksunten + 5], [x_linksunten + seitenlaenge + abstand, y_linksunten + 5], 2)
    pygame.draw.line(screen, black, [x_linksunten + abstand + seitenlaenge*1/4, y_linksunten + 5], [x_linksunten + abstand, y_linksunten + 10] , 2)
    pygame.draw.line(screen, black, [x_linksunten + abstand + seitenlaenge*2/4, y_linksunten + 5], [x_linksunten + seitenlaenge*1/4 + abstand, y_linksunten + 10] , 2)
    pygame.draw.line(screen, black, [x_linksunten + abstand + seitenlaenge*3/4, y_linksunten + 5], [x_linksunten + seitenlaenge*2/4 + abstand, y_linksunten + 10] , 2)
    pygame.draw.line(screen, black, [x_linksunten + abstand + seitenlaenge, y_linksunten + 5], [x_linksunten + seitenlaenge*3/4 + abstand, y_linksunten + 10] , 2)
    pygame.display.update()

    spitze2 = (x_linksunten + seitenlaenge/2 + abstand , y_linksunten - math.sqrt(seitenlaenge**2 - (seitenlaenge/2)**2) )



#Eingabefeld und Aufforderungstext für den Abstand zwischen den Lagern
def draw_eingabefeld_abstand():
    abstand_aufforderung = comicsans_g.render("Abstand zwischen den Lagern in Meter: ", 1, black)
    hinweis = comicsans_kl.render('(Zahlen eingeben, zum Schluss mit "Enter" bestätigen)', 1, black)

    text_x = white_width/2 - abstand_aufforderung.get_width()/2
    text_y = abst_y - abstand_aufforderung.get_height() - 10

    text_x2 = white_width/2 - hinweis.get_width()/2
    text_y2 = abst_y+ abst_hoehe + 10

    pygame.draw.rect(screen, darkgrey, abstand_feld)
    screen.blit(abstand_aufforderung, (text_x, text_y))
    screen.blit(hinweis, (text_x2, text_y2))

# zurücksetzen des Bildschirms
def normales_layout():
    screen.fill(white)
    draw_menu()
    draw_resetoptions()
    draw_fertig()
    draw_quit()


def draw_kraftpunktfeld():
    global kraft_punkt_benoetigt

    pygame.draw.rect(screen, darkgrey, kf)

    punkt_text1 = comicsans_20.render("Klicke den Knotenpunkt an,", 1, black)
    punkt_text2 = comicsans_20.render("an dem die Kraft angreift.", 1, black)

    text_x1 = ((3/4*width-10)-kf_laenge + kf_laenge/2)-punkt_text1.get_width()/2
    text_y1 = (10+kf_hoehe/2)-punkt_text1.get_height() - 1

    text_x2 = ((3/4*width-10)-kf_laenge + kf_laenge/2)-punkt_text2.get_width()/2
    text_y2 = (10+kf_hoehe/2)-punkt_text2.get_height()/2 + punkt_text2.get_height() + 1

    screen.blit(punkt_text1, (text_x1, text_y1))
    screen.blit(punkt_text2, (text_x2, text_y2))

    kraft_punkt_benoetigt = True

def draw_kraftrichtungfeld():
    pygame.draw.rect(screen, grey, kf_richtung)

    pygame.draw.rect(screen, white, kleine_optionen1)
    pygame.draw.rect(screen, white, kleine_optionen2)
    #pygame.draw.rect(screen, white, kleine_optionen3)

    richtung_text = comicsans.render("Richtung der Kraft: ", 1, black)

    option_senkrecht = comicsans_20.render("Senkrecht", 1, black)
    option_waagerecht = comicsans_20.render("Waagerecht", 1, black)
    #option_selbst1 = comicsans_20.render("Selbst", 1, black)
    #option_selbst2 = comicsans_20.render("einstellen", 1, black)

    screen.blit(richtung_text, ((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4), 10 + kf_hoehe/4 - richtung_text.get_height()/2)) #((3/4*width-10)-kf_laenge) + kf_laenge/2 - richtung_text.get_width()/2
    screen.blit(option_senkrecht, ((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) + (1/2*(1/2*(1/4*width)))/2 - option_senkrecht.get_width()/2, 10+kf_hoehe/2 + (1/2*(1/3*(1/3*height)))/2 - option_senkrecht.get_height()/2))
    screen.blit(option_waagerecht, ((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2)+1/2*(1/2*(1/4*width))+ (1/2*(1/2*(1/4*width)))/2 - option_waagerecht.get_width()/2, 10+kf_hoehe/2 + (1/2*(1/3*(1/3*height)))/2 - option_waagerecht.get_height()/2))
    #screen.blit(option_selbst1, ((3/4*width-10)-kf_laenge+3*((kf_laenge-3*1/2*(1/2*(1/4*width)))/4)+2*1/2*(1/2*(1/4*width))  + (1/2*(1/2*(1/4*width)))/2 - option_selbst1.get_width()/2, 10+kf_hoehe/2 + (1/2*(1/3*(1/3*height)))/4 - option_selbst1.get_height()/2 + 5))
    #screen.blit(option_selbst2, ((3/4*width-10)-kf_laenge+3*((kf_laenge-3*1/2*(1/2*(1/4*width)))/4)+2*1/2*(1/2*(1/4*width))  + (1/2*(1/2*(1/4*width)))/2 - option_selbst2.get_width()/2, 10+kf_hoehe/2 + (1/2*(1/3*(1/3*height)))*3/4 - option_selbst2.get_height()/2 - 5))



def draw_arrow_senkrecht(ende, laenge, force_dir, n=1):
    start = ende - laenge*force_dir

    seite1_vektor = [math.sin(45) * 5, math.cos(45) * 5*n]
    seite2_vektor = [math.sin(45) * -5, math.cos(45) * 5*n]
    seite1_start = [(ende[0] - seite1_vektor[0]), (ende[1] - seite1_vektor[1])]
    seite2_start = [(ende[0] - seite2_vektor[0]), (ende[1] - seite2_vektor[1])]

    pygame.draw.line(screen, blue, start, ende, 2)
    pygame.draw.line(screen, blue, seite1_start, ende, 2)
    pygame.draw.line(screen, blue, seite2_start, ende, 2)

def draw_arrow_waagerecht(ende, laenge, force_dir, n=1):
    start = ende - laenge*force_dir

    seite1_vektor = [math.sin(45) * 5*n, math.cos(45) * 5]
    seite2_vektor = [math.sin(45) * 5*n, math.cos(45) * -5]
    seite1_start = [(ende[0] - seite1_vektor[0]), (ende[1] - seite1_vektor[1])]
    seite2_start = [(ende[0] - seite2_vektor[0]), (ende[1] - seite2_vektor[1])]

    pygame.draw.line(screen, blue, start, ende, 2)
    pygame.draw.line(screen, blue, seite1_start, ende, 2)
    pygame.draw.line(screen, blue, seite2_start, ende, 2)

def draw_optionen_senkrecht():
    global kf_laenge
    global kf_hoehe

    von_oben = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),(1/2*(1/3*(1/3*height))))
    von_unten = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) + 1/2*(1/2*(1/2*(1/4*width))), 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))), 1/2*(1/3*(1/3*height)))

    pygame.draw.rect(screen, white, von_oben)
    pygame.draw.rect(screen, white, von_unten)

    pygame.draw.line(screen, black, [(3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) + 1/2*(1/2*(1/2*(1/4*width))) + 2, 10+kf_hoehe/2],[(3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4) + 1/2*(1/2*(1/2*(1/4*width))) + 2,10+kf_hoehe/2 + (1/2*(1/3*(1/3*height)))], 4)

    x_ecke1 = (3/4*width-10)-kf_laenge+((kf_laenge-3*(1/2*(1/2*(1/4*width))))/4)
    y_ecke1 = 10+kf_hoehe/2
    kleiner_block_breite = 1/2*(1/2*(1/2*(1/4*width)))
    kleiner_block_hoehe = (1/2*(1/3*(1/3*height)))

    draw_arrow_senkrecht([x_ecke1 + kleiner_block_breite/2 + 1, y_ecke1 + 3/4*kleiner_block_hoehe], 1/2*kleiner_block_hoehe, np.array([0,1]))
    draw_arrow_senkrecht([x_ecke1 + kleiner_block_breite/2 + 1 + kleiner_block_breite, y_ecke1 + 1/4*kleiner_block_hoehe], -1/2*kleiner_block_hoehe, np.array([0,1]), n=-1)

def draw_optionen_waagerecht():
    global kf_laenge
    global kf_hoehe

    von_links = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width))) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),1/2*(1/3*(1/3*height)))
    von_rechts = pygame.Rect((3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width))) + 1/2*(1/2*(1/2*(1/4*width))) , 10+kf_hoehe/2 , 1/2*(1/2*(1/2*(1/4*width))),1/2*(1/3*(1/3*height)))


    pygame.draw.rect(screen, white, von_links)
    pygame.draw.rect(screen, white, von_rechts)


    x_ecke1 = (3/4*width-10)-kf_laenge+((kf_laenge-3*1/2*(1/2*(1/4*width)))/2+1/2*(1/2*(1/4*width)))
    y_ecke1 = 10+kf_hoehe/2
    kleiner_block_breite = 1/2*(1/2*(1/2*(1/4*width)))
    kleiner_block_hoehe = 1/2*(1/3*(1/3*height))

    pygame.draw.line(screen, black, [x_ecke1 + 2 + kleiner_block_breite, y_ecke1], [x_ecke1 + 2 + kleiner_block_breite,y_ecke1 + kleiner_block_hoehe], 4)

    draw_arrow_waagerecht([x_ecke1 + 3/4*kleiner_block_breite  , y_ecke1 + kleiner_block_hoehe/2 - 1], 1/2*kleiner_block_breite, np.array([1,0]))
    draw_arrow_waagerecht([x_ecke1 + kleiner_block_breite + 1/4*kleiner_block_breite, y_ecke1 + kleiner_block_hoehe/2 - 1], -1/2*kleiner_block_breite, np.array([1,0]), n=-1)

def draw_berechnen_oder_kraft():


    text_berechnen = comicsans_g.render("Berechnen", 1, black)
    text_kraft1 = comicsans.render("weitere Kraft", 1, black)
    text_kraft2 = comicsans.render("hinzufügen", 1, black)

    pygame.draw.rect(screen, grey, kf)


    fb_laenge = 0.8*(1/2*kf_laenge)
    fb_hoehe = 0.8*kf_hoehe
    fb_x = kf_x + 0.1*(1/2*kf_laenge)
    fb_y = kf_y + 0.1*kf_hoehe

    fwk_laenge = fb_laenge
    fwk_hoehe = fb_hoehe
    fwk_x = fb_x + 1/2*kf_laenge
    fwk_y = fb_y

    feld_berechnen = pygame.Rect(fb_x, fb_y, fb_laenge, fb_hoehe)
    pygame.draw.rect(screen, white, feld_berechnen)
    screen.blit(text_berechnen, (fb_x + fb_laenge*1/2 - text_berechnen.get_width()/2,fb_y + fb_hoehe*1/2 - text_berechnen.get_height()/2 ))

    feld_weitere_kraft = pygame.Rect(fwk_x, fwk_y, fwk_laenge, fwk_hoehe)
    pygame.draw.rect(screen, white, feld_weitere_kraft)
    screen.blit(text_kraft1, (fwk_x + fwk_laenge*1/2 - text_kraft1.get_width()/2, fb_y + fb_hoehe*1/2 - text_kraft1.get_height() ))
    screen.blit(text_kraft2, (fwk_x + fwk_laenge*1/2 - text_kraft2.get_width()/2, fb_y + fb_hoehe*1/2 + text_kraft2.get_height()/2 ))

def click_berechnen():

    points = []
    points.append(knotenpunkte[0])
    for i in knotenpunkte[2:]:
        points.append(tuple(i))
    print("Liste der Beträge der Kräfte:", kraft_liste)
    print("Liste der Knotenpunkte:", points)
    print("Liste der Richtungen der Kräfte:", kraft_dir)
    print("Maximale Lagerkraft:", lagerkraft_betrag)
    print("Maximale Stabkraft:", stabkraft_betrag)



    force_val = kraft_liste
    print(kraft_punkt_liste)
    start_cords = knotenpunkte[0]
    end_cords = knotenpunkte[1]
    force_cords = kraft_punkt_liste

    # Maximal zulässige Belastungen
    A_x_zul = lagerkraft_betrag
    A_y_zul = lagerkraft_betrag
    B_y_zul = lagerkraft_betrag
    stab_zul = stabkraft_betrag

    # Richtung der Kraft
    force_dir = kraft_dir

    # Kraft in x/y-Richtung
    #force_x = f_x(force_dir, force_val)
    #force_y = f_y(force_dir, force_val)

    # Anzahl einzigartiger Knotenpunkte, Liste einzigartiger Knotenpunkte
    amount_knoten = len(set(points))
    knoten = list(set(points))
    # Alle Verbindungen zwischen 2 Punkten
    connections = []
    for i in range(len(points) - 1):
        if [points[i], points[i+1]] and [points[i+1], points[i]] not in connections:
            connections.append([points[i], points[i+1]])

    # Arrays zur Berechnung der Stab-und Lagerkräfte
    N = np.zeros((amount_knoten * 2, amount_knoten * 2))
    y = np.zeros((amount_knoten * 2))

    # Stabrichtung
    s_dir = (0, 0)


    # Berechnung der Werte der Arrays zur Berechnung der Stab-und Lagerkräfte
    for i in range(len(knoten)):

        for j in range(len(connections)):
            if knoten[i] in connections[j]:
                if knoten[i] == connections[j][0]:
                    s_dir = vector(connections[j])
                if knoten[i] == connections[j][1]:
                    s_dir = vector([connections[j][1], connections[j][0]])
                N[i * 2, j] = s_dir[0] / (np.sqrt(s_dir[0] ** 2 + s_dir[1] ** 2))
                N[i * 2 + 1, j] = s_dir[1] / (np.sqrt(s_dir[0] ** 2 + s_dir[1] ** 2))
                if knoten[i] == end_cords:
                    N[i * 2 + 1, len(connections) + 2] = 1
                if knoten[i] == start_cords:
                    N[i * 2, len(connections)] = 1
                    N[i * 2 + 1, len(connections) + 1] = 1
                for k in range(len(force_val)):
                    print(knoten[i])
                    print(force_cords[k])
                    if knoten[i] == tuple(force_cords[k]):
                        y[i * 2] += - f_x(force_dir[k], force_val[k])
                        y[i * 2 + 1] += - f_y(force_dir[k], force_val[k])

    # Array mit den Ergebnissen
    print(y)
    staebe = np.linalg.solve(N, y)
    print(staebe)
    stabil = True

    for i in staebe[:amount_knoten * 2 - 3]:
        if abs(i) > stab_zul:
            stabil = False
            #stab = False
            print("Belastung zu groß (Stabkraft)")

    if abs(staebe[amount_knoten * 2 - 3]) > A_x_zul:
        stabil = False
        #A_x = False
        print("Belastung zu groß (Ax)")

    if abs(staebe[amount_knoten * 2 - 2]) > A_y_zul:
        stabil = False
        #A_y = False
        print("Belastung zu groß (Ay)")

    if abs(staebe[amount_knoten * 2 - 1]) > B_y_zul:
        stabil = False
        #B_y = False
        print("Belastung zu groß (By)")

    if stabil:
        meldung_stabil()
    else:
        meldung_instabil()


def meldung_stabil():

    global height
    global white_width

    kasten_rot_text1 = comicsans.render("Sehr Gut:", 1, black)
    kasten_rot_text2 = comicsans.render("Die Konstruktion ist stabil!", 1, black)

    k_rot_hoehe = 2*(kasten_rot_text1.get_height()+kasten_rot_text2.get_height())
    k_rot_breite = kasten_rot_text2.get_width() + 1/3*kasten_rot_text2.get_width()

    k_rot_x = white_width/2 - k_rot_breite/2
    k_rot_y = height/2 - k_rot_hoehe/2

    kasten_rot = pygame.Rect(k_rot_x, k_rot_y, k_rot_breite, k_rot_hoehe)
    pygame.draw.rect(screen, green, kasten_rot)

    screen.blit(kasten_rot_text1, (white_width/2 - kasten_rot_text1.get_width()/2, height/2-k_rot_hoehe/4 - kasten_rot_text1.get_height()/2)  )
    screen.blit(kasten_rot_text2, (white_width/2 - kasten_rot_text2.get_width()/2, height/2+k_rot_hoehe/4 - kasten_rot_text2.get_height()/2)  )

def meldung_instabil():

    global height
    global white_width

    kasten_rot_text1 = comicsans.render("Schade:", 1, black)
    kasten_rot_text2 = comicsans.render("Die Konstruktion ist nicht stabil!", 1, black)

    k_rot_hoehe = 2*(kasten_rot_text1.get_height()+kasten_rot_text2.get_height())
    k_rot_breite = kasten_rot_text2.get_width() + 1/3*kasten_rot_text2.get_width()

    k_rot_x = white_width/2 - k_rot_breite/2
    k_rot_y = height/2 - k_rot_hoehe/2

    kasten_rot = pygame.Rect(k_rot_x, k_rot_y, k_rot_breite, k_rot_hoehe)
    pygame.draw.rect(screen, red, kasten_rot)

    screen.blit(kasten_rot_text1, (white_width/2 - kasten_rot_text1.get_width()/2, height/2-k_rot_hoehe/4 - kasten_rot_text1.get_height()/2)  )
    screen.blit(kasten_rot_text2, (white_width/2 - kasten_rot_text2.get_width()/2, height/2+k_rot_hoehe/4 - kasten_rot_text2.get_height()/2)  )


# Berechnet die Kraft in x-Richtung
def f_x(f_dir, f_val):
    return f_val * (f_dir[0] / (np.sqrt(f_dir[0] ** 2 + f_dir[1] ** 2)))

# Berechnet die Kraft in y-Richtung
def f_y(f_dir, f_val):
    return f_val * (f_dir[1] / (np.sqrt(f_dir[0] ** 2 + f_dir[1] ** 2)))

# Ermittelt einen Vektor ausgehend von 2 Punkten
def vector(related):
    return (related[1][0] - related[0][0], related[0][1] - related[1][1])



def click_weitere_kraft():
    click_fertig()


# Anmerkung: Knotenpunkt am Rand abgeschnitten --> Begrenzung einfügen
# wenn man ausversehen auf die Zahlen kommt, wird abstand geändert --> gelöst
# abstand > 675 (doch nicht, andere Zahl, Festlager muss mit beachtet werden)--> nicht mehr im (weißen) Feld --> Fehlermeldung? Verkleinerung des Maßstabes?



# Noch machen:
# wenn auf Lager geklickt --> das auch ausgewählt (Knotenpunkt) ERLEDIGT
# Startpunkt = Festlager ERLEDIGT (bzw. soll man nicht mehr klicken müssen?)
# Dreieckmethode oder Doppellinien?
# Festlager und Loslager besser zeichnen (--> Striche)

# Fertig-Feld kann im Krafteingabemodus noch gedrückt werden ---> noch zu beheben
# Stäbe können nach dem drücken auf fertig noch verändert werden ---> noch zu beheben




if __name__ == "__main__":
    main()

# Verbesserungen:
# * nicht nur waagerecht und senkrecht / Feldgröße anpassen
# * Einelne Zeichen der Einagbe löschen
